#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import time
import verwaltungmysql
import sortieren
import kontenplan
import types
import htmlutilities
import gemeindekarteimysql
import optionen
import verschiedeneUtilities

datumsform = re.compile(r"\d\d\d\d-\d\d-\d\d")
primaerkartei = 'Buchungsnummer'
vorlagen = "baukontoneu_vorlagen"
tabuschluessel = [primaerkartei,'Belegnummer','Buchungsdatum','BearbeitetVon']
##backupdatei = "/windowsc/Martin/verwalt/Gemeindekartei/bezirksreiterbaukonto2002.txt"
##if sys.platform[:3]=="win":
##    backupdatei = r"c:\Martin\verwalt\Gemeindekartei\bezirksreiterbaukonto2002.txt"
##    # anderer Pfad fr Windows

Benutzername = ""
User = ""
# wird von verwaltungMainServer gesetzt

class BaukontoNormal(verwaltungmysql.MySQLZugriff):

    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="baukontoneu"):
        self.buchungsjahr = buchungsjahr
        self.tabelle = "%s%s" % (tabelle,self.buchungsjahr)
        # fr jedes Buchungsjahr eine eigene Tabelle!
        verwaltungmysql.MySQLZugriff.__init__(self,MysqlDatenbank,datenbank,self.tabelle)
        self.Kontenplan = kontenplan.BaukontoKontenplan(MysqlDatenbank,self.buchungsjahr)
        self.kontendict = self.Kontenplan.alleAlsDictionary()
        self.gemeindekartei = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank, self.buchungsjahr)
        self.optionen = optionen.Optionen(MysqlDatenbank,self.buchungsjahr)
        self.kontenInit()       

    def kontenInit(self):
        self.habenKonten = ["Habenkonto_1","Habenkonto_2","Habenkonto_3"]
        self.sollKonten = ["Sollkonto_1","Sollkonto_2","Sollkonto_3"]
        self.Konten = self.habenKonten + self.sollKonten

    def eintragLoeschen(self,schluessel,tabelle=None):
        return verwaltungmysql.MySQLZugriff.eintragLoeschen(self,primaerkartei,schluessel,tabelle=tabelle)
        
    def spendername(self,schluessel,alleDaten="nein"):
        return self.gemeindekartei.spendername(schluessel,alleDaten="nein")
       ## rueckdict = {}
##        tempdict = self.gemeindekartei.schluesselSuchen(schluessel)[0]
##        try:
##            if alleDaten == "ja":
##                rueckdict.update(tempdict)
##                # so werden alle Daten bertragen. Das kann zu Verwirrungen fhren:
##                # beispielsweise enthlt auch ein Buchungssatz eine Kategorie "Bemerkungen".
##            rueckdict["Spendername"] = "%s, %s" % (tempdict["Nachname"], tempdict["Vorname"])
##            rueckdict["MZ"] = "%s" % tempdict["MZ"]
##            # wir brauchen einen String fr die MZ.
##        except:
##            rueckdict["Spendername"] = "-"
##            rueckdict["MZ"] = "0"
##        return rueckdict

    def letzterMonatsbeitrag(self,schluessel,sicherheitsloeschen="ja"):
        """Gibt den Buchungssatz zurck, der den letzten Monatsbeitrag von schluessel enthlt."""
        befehl = """select * from %s where MZ like "%s" and Buchungstext like "%s" order by Belegdatum""" % (self.Tabellenname,schluessel,"%monatsbeitrag%")
        # das "spezielle" Einsetzen von %monatsbeitrag%, damit die %s - Funktion nicht nach noch mehr
        # Variablen sucht - ein kleiner Python-Fehler?
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall() 
        try:
            temp = self.alsDictionary(self.Spaltennamen,temp)
            if sicherheitsloeschen == "ja":
                temp1 = self.sicherheitsLoeschen(temp[-1])
                temp1["Buchungstext"] = "Monatsbeitrag"
                return temp1
            else:
                return temp[-1]
        except:
            # kein Eintrag gefunden: bliche Spendenbuchung
            temp1 = self.holeLeerenEintrag()
            temp1.update(self.spendername(schluessel))
            return temp1
        

    def primaerschluessel(self):
        return primaerkartei

    def tabuschluesselEntfernen(self,dict):
        return verwaltungmysql.MySQLZugriff.tabuschluesselEntfernen(self,dict,tabuschluessel)

    
##    def sicherungsdatei(self):
##        return backupdatei

    def neuerEintrag(self,neudict,primaerdummy=primaerkartei,schluesselwert=None,tabelle=None):
        """berschreibt die Funktion in der bergeordneten Klasse MySQLZugriff"""
        if tabelle is None:
            tabelle = self.Tabellenname
        primaerdummy = primaerkartei
        # Damit man es nicht versehentlich falsch aufrufen kann...
        # Achtung, bei dieser Klasse wird der Primrschlssel von MySQL per
        # auto_increment erzeugt!
        uebergabedict = self.holeLeerenEintrag()
        uebergabedict.update(neudict)
        uebergabedict = self.tabuschluesselEntfernen(neudict)
        test = self.buchungPruefen(uebergabedict)
        neubelegnummer = 0
        if test != 0:
            uebergabedict["BearbeitetVon"] = Benutzername
            self.neuerEintragDirekt(uebergabedict)
            neubelegnummer = self.letzterAutoEintrag()
            neuablagenummer = "%s-%s-%s%s" % (uebergabedict["Belegdatum"],neubelegnummer,self.Datenbankname,self.buchungsjahr)
            # Damit kann man schn ablegen, sogar nach Einnahme- und Ausgabe-
            # belegen getrennt...
            self.eintragAendern({"Belegnummer": neuablagenummer},primaerkartei,neubelegnummer)
        return neubelegnummer

    def inVorlagenKopieren(self,schluessel):
        """Kopiert einen Eintrag in die Datenbank vorlagen (s.o.)"""
        tempdict = self.schluesselSuchen(schluessel)[0]
        tempdict = self.tabuschluesselEntfernen(tempdict)
        del tempdict["Belegdatum"]
        self.neuerEintragDirekt(tempdict,tabelle="%s%s" % (vorlagen,self.buchungsjahr))
        return self.letzterAutoEintrag()

    def inVorlagenLoeschen(self,schluessel):
        self.eintragLoeschen(schluessel,tabelle="%s%s" % (vorlagen,self.buchungsjahr))

    def sicherheitsLoeschen(self,dict):
        try:
            dict["Buchungsnummer"] = "-"
            dict["Buchungsdatum"] = "-"
            dict["Belegdatum"] = "-"
            dict["Belegnummer"] = "-"
            # Werden nicht gebraucht!
        except:
            pass
        return dict

    def inVorlagenHolen(self,schluessel,sicherheitsloeschen="ja"):
        temp = self.eintragSuchfunktion({primaerkartei: schluessel},tabelle="%s%s" % (vorlagen,self.buchungsjahr))[0]
        if sicherheitsloeschen == "ja":
            temp = self.sicherheitsLoeschen(temp)            
        return temp
            

    def alleVorlagenHolen(self):
        return self.sortierteListe("Buchungstext",tabelle="%s%s" % (vorlagen,self.buchungsjahr))

    def alleKontenPruefen(self,schluessel,sortierkategorie="Belegnummer",grundstueck=None,gemeinde=None):
        """Gibt alle Buchungen zurck, bei denen schluessel auf irgendeinem (!) der Konten vorkommt."""
        zusatzbedingung = ""
        if grundstueck is not None:
            zusatzbedingung += """ and (Grundstueck like "%s") """ % grundstueck
        if gemeinde is not None:
            zusatzbedingung += """ and (Gemeinde like "%s") """ % gemeinde
        temp = self.oderListeAbfragen(schluessel,self.Konten,sortierkategorie,zusatzbedingung)
        if not temp[0]:
            # Kein Eintrag gefunden
            return 0
        else:
            return temp

    def storno(self,schluessel):
        """Klassisches Storno ohne Lschen des Eintrags. Unelegant codiert..."""
        stornodict = self.eintragSuchfunktion({primaerkartei: schluessel})[0]
        neudict = {}
        neudict.update(stornodict)
        neudict["Sollkonto_1"] = stornodict["Habenkonto_1"]
        neudict["Sollkonto_2"] = stornodict["Habenkonto_2"]
        neudict["Sollkonto_3"] = stornodict["Habenkonto_3"]
        neudict["Habenkonto_1"] = stornodict["Sollkonto_1"]
        neudict["Habenkonto_2"] = stornodict["Sollkonto_2"]
        neudict["Habenkonto_3"] = stornodict["Sollkonto_3"]
        neudict["BetragSoll_1"] = stornodict["BetragHaben_1"]
        neudict["BetragSoll_2"] = stornodict["BetragHaben_2"]
        neudict["BetragSoll_3"] = stornodict["BetragHaben_3"]
        neudict["BetragHaben_1"] = stornodict["BetragSoll_1"]
        neudict["BetragHaben_2"] = stornodict["BetragSoll_2"]
        neudict["BetragHaben_3"] = stornodict["BetragSoll_3"]
        neudict["Buchungstext"] = "Storno: "+stornodict["Buchungstext"]
        neudict["Stornonummer"] = schluessel
        return self.neuerEintrag(neudict)        

    def buchungPruefen(self,dict):
        """Eine entscheidende Funktion, die (leider?) hartcodiert und sehr spezialisiert ist."""
        haben = float(dict['BetragHaben_1'])+float(dict['BetragHaben_2'])+float(dict['BetragHaben_3'])
        soll = float(dict['BetragSoll_1'])+float(dict['BetragSoll_2'])+float(dict['BetragSoll_3'])
        #print "type",type(haben),type(soll),"\n"
        flag = 1
        for i in self.Konten:
            if dict[i] in self.optionen.alleSpendenkonten() and dict["Squittung_noetig"] == "nein" and ("%s" % dict["Stornonummer"] == "0"):
                print "Achtung: Wirklich keine Spendenquittung fr %s?" % i
        if abs(soll-haben) > 0.00001:
            # Achtung, Rundungsfehler!
            print "Soll und Haben stimmen nicht berein!"
            flag = 0       
        if dict["Belegdatum"] == "-" or dict["Belegdatum"] == "00.00.0000":
            print "Sie mssen ein Belegdatum angeben!"
            flag = 0
        try:
            temp = datumutilities.Datum(dict["Belegdatum"])
        except:
            print "Das Belegdatum ist ungltig(falsches Format, nichtexistentes Datum)!"
            flag = 0
            
        if dict["Buchungstext"] == "-":
            print "Sie mssen einen Buchungstext angeben!"
            flag = 0
        try:
            if dict["Spendername"] != self.spendername(dict["MZ"])["Spendername"]:
                print "MZ und Spendername stimmen nicht berein!"
                flag = 0
        except:
            # Wenn der Spendername nicht relevant ist und der dict die keys nicht hat.
            pass
        if dict["Sollkonto_1"] == dict["Habenkonto_1"]:
            print "Sollkonto_1 und Habenkonto_1 stimmen berein: Tippfehler?"
            flag = 0
        if dict["Sollkonto_1"] == "-" or dict["Habenkonto_1"] == "-":
            print "Sollkonto_1 und Habenkonto_1 drfen nicht unbestimmt bleiben!"
            flag = 0
        kontenflag = 0
        for i in self.Konten:
            if dict[i] != "-":
                kontenflag = 1
                try:
                    temp = self.Kontenplan.schluesselSuchen(dict[i])[0]
                except:
                    print "Fr %s: Kontonummer existiert nicht!" % i
                # print "temp",temp,"dict[i]",dict[i],"\n"
                if temp["GemeindeNoetig"] == "ja" and dict["Gemeinde"] == "-":
                    print "Fr %s: Sie mssen eine Gemeinde angeben!" % i
                    flag = 0
                if temp["GrundstueckNoetig"] == "ja" and dict["Grundstueck"] == "-":
                    print "Fr %s: Sie mssen ein Grundstck angeben!" % i
                    flag = 0
                if temp["MZNoetig"] == "ja" and "%s" % dict["MZ"] == "0":
                    print "Fr %s: Sie mssen eine Person mit MZ angeben!" % i
                    flag = 0
        if kontenflag == 0:
            print "Sie haben keine Konten angegeben!"
            flag = 0
        return flag

    def wformat(self,string):
        """Umwandlung in Whrungsformat mit zwei Nachkommastellen. Gibt es so hnlich auch in baukontoweb."""
        try:
            string = "%.2f" % round(float(string),2)
            if string == "0.00":
                return "-"
            else:
                return string
        except:
            if string == "None":
                return "-"
            else:
                return string

    def summeSollHaben(self,kontonummer,mitStornos="ja",mitKontonummer="ja",grundstueck=None,gemeinde=None,wformat="nein",mitVorzeichen="ja"):
        """Gibt den Saldo eines Kontos, gerechnet ber smtliche Buchungen. Bei 'mit Stornos' werden die
        Stornobuchungen mit bercksichtigt. => Achtung, nicht so in der Jahresstatistik!"""
        stornos = self.alleStornosSQL()
        SollHaben = {"Soll": 0, "Haben": 0}
        for i in ["1","2","3"]:
            for j in ["Soll","Haben"]:
                befehl = """select sum(Betrag%s_%s) from %s where %skonto_%s like "%s" """ % (j,i,self.Tabellenname,j,i,kontonummer)
                if mitStornos == "nein":
                    befehl += """ and Buchungsnummer not in %s """ % stornos
                if grundstueck is not None:
                    befehl += """ and Grundstueck like "%s" """ % grundstueck
                if gemeinde is not None:
                    befehl += """ and Gemeinde like "%s" """ % gemeinde    
                self.Cursor.execute(befehl)
                temp = self.Cursor.fetchone()[0]
                if type(temp) == types.FloatType:
                    SollHaben[j] += temp
        SollHaben["SollMinusHaben"] = SollHaben["Soll"] - SollHaben["Haben"]
        if mitKontonummer=="ja":
            SollHaben["Kontonummer"] = kontonummer
        ## for i in SollHaben.keys():
            ## SollHaben[i] = round(SollHaben[i],2)
            # am Schlu werden die Rundungsfehler von Python ausgebgelt... => Besser erst spter!
        if wformat == "ja":
            for i in ["Soll","Haben","SollMinusHaben"]:
                temp = SollHaben[i]
                if mitVorzeichen == "nein":
                    temp = abs(temp)
                SollHaben[i] = self.wformat("%s" % temp)
        return SollHaben

    
    def summeSollHabenAlle(self,mitStornos="ja",mitKontonummer="ja",liste=None):
        dictarray = []
        if liste is None:
            liste = self.Kontenplan.kontenListe()
        else:
            liste.sort()
        for i in liste:
            dictarray.append(self.summeSollHaben(i,mitStornos,mitKontonummer))
        return dictarray

    def summeSollHabenUnterkonten(self,Hauptkonto,mitStornos="ja",mitKontonummer="ja"):
        liste = self.Kontenplan.alleUnterkonten(Hauptkonto)
        return self.summeSollHabenAlle(mitStornos,mitKontonummer,liste)

    def summeSollHabenHauptkonto(self,Hauptkonto,mitStornos="ja",mitKontonummer="ja",var_dict=None):
        sumdict = {} # hier initialisiert, damit nur als lokale Variable behandelt
        if var_dict is None:
            sumdict = {"SollMinusHaben": 0, "Soll": 0, "Haben": 0}
        else:
            sumdict = var_dict
        for i in self.Kontenplan.alleUnterkonten(Hauptkonto):
            tempdict = self.summeSollHaben(i,mitStornos=mitStornos,mitKontonummer="nein")
            for j in tempdict.keys():
                sumdict[j] += tempdict[j]
        if mitKontonummer=="ja":
                sumdict["Hauptkonto"] = Hauptkonto
        return sumdict

    def summmeSollHabenAlleHauptkonten(self,mitStornos="ja",mitKontonummer="ja"):
        dictarray = []
        for i in self.Kontenplan.hauptkontenListe():
            dictarray.append(self.summeSollHabenHauptkonto(i,mitStornos,mitKontonummer))
        return dictarray

    def summeBaukonto(self):
        return self.summeSollHaben("41022")

    def summeBaukasseBar(self):
        return self.summeSollHaben("41012")

    def eintragVergleichen(self,schluessel,vergleichdict):
        vergleichdictvollstaendig = self.leererEintrag
        vergleichdictvollstaendig.update(vergleichdict)
        # wichtig, wenn in vergleichdict bestimmte Eintrge fehlen,
        # die z.B. in einem Eingabeformular von "Name" auf "" gesetzt wurden.
        # Sie wrden sonst nicht verglichen (vgl. die Superklasse).
        return verwaltungmysql.MySQLZugriff.eintragVergleichen(self,{primaerkartei:schluessel},vergleichdictvollstaendig)

    def schluesselSuchen(self,schluessel):
        return self.eintragSuchfunktion({primaerkartei: schluessel})

    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel=""):
        # Parameter "primaerschluessel" nur aus Kompatibilitt, damit die Schnittstelle
        # noch 4 Parameter hat.
        if aenderungsdict.has_key(primaerkartei):
            # kein ndern des Primrschlssels!
            del aenderungsdict[primaerkartei]
        verwaltungmysql.MySQLZugriff.eintragAendern(self,aenderungsdict,primaerkartei,schluessel)

    def spendenquittungRegistrieren(self,buchungsliste):
        """Setzt bei den bergebenen Buchungsnummern das Feld
        "Squittung_erstellt" auf das aktuelle Datum."""
        heute = self.Datumwerkzeug.deutschesFormat()
        for buchung in buchungsliste:
            self.eintragAendern({"Squittung_erstellt": heute},primaerkartei,buchung)
            # bei nachtrglich erzwungenen Quittungen, wo ursprnglich "Squittung_noetig" = "nein"
            # eingetragen war, werden diese beim Quittungsausdruck immer automatisch den kirchlichen,
            # nicht den mildttigen Spenden zugeschlagen. Aber: steuerlich ist das gewhnlich
            # kaum relevant.

    def alleStornos(self):
        """Gibt die Buchungsnummer aller Stornobuchungen und ihrer stornierten Gegenstcke
        zurck. Wird z.B. gebraucht, wenn alle wieder stornierten Buchungen nicht bei
        der Spendenbersicht gebraucht werden."""
        befehl = """select a.Buchungsnummer, b.Buchungsnummer from %s a, %s b where a.Buchungsnummer like b.Stornonummer""" % (self.tabelle,self.tabelle)
        try:
            self.Cursor.execute(befehl)
            temparray = self.Cursor.fetchall()
            stornoliste = [i[0] for i in temparray]
            stornoliste += [i[1] for i in temparray]
            return stornoliste
        except:
            return []

    def alleStornosSQL(self):
        return self.listeAlsSQL(self.alleStornos())

    def alleSpender(self):
        befehl = """select distinct MZ from %s where MZ not like "0" """ % (self.tabelle)
        # das bercksichtigt nicht den unwahrscheinlichen (?) Fall, da eine MZ eingetragen ist
        # in der Buchung, ohne da etwas gespendet wurde. Aber das wird in spendenUebersicht()
        # ja noch abgeprft.
        self.Cursor.execute(befehl)
        try:
            temp = self.Cursor.fetchall()
            # Umwandlung, denn temp ist eine Liste von einelementigen Listen.
            # Rckgabe als String, nicht als Zahl.
            return ["%s" % i[0] for i in temp]
        except:
            # wenn keiner etwas gespendet hat, bleibt die leere Liste.
            return []

    def alleSpenderSQL(self):
        return self.listeAlsSQL(self.alleSpender())

    def spendenUebersicht(self,MZ,alleSpenden,auswahlliste=None):
        """Gibt einen berblick aller spendenrelevanten Buchungen zu einer gegebenen MZ.
        Es wird jede Spende erfat, die in den relevanten Spendenkonten gebucht wurde.
        Wenn ein Buchungssatz mehrere Spenden erfate, werden mehrere Zeilen ausgegeben.
        Durch "auswahlliste" kann die Suche auf bestimmte Buchungsnummern beschrnkt werden."""
        Spendenkonten = self.optionen.alleSpendenkontenSQL()
        auswahlliste_sql = ""
        if auswahlliste:
            auswahlliste_sql = """and Buchungsnummer in %s""" % self.listeAlsSQL(auswahlliste)
        spendenquittung = ""
        if alleSpenden=="nein":
            spendenquittung = """ and SQuittung_noetig in ("ja","kirchlich","mildttig") and Squittung_erstellt like "%nein%" """
            # so werden nur die erfat, fr die noch eine Quittung erstellt werden mu.
        spendenbuchungen = []
        stornos = self.alleStornosSQL()
        # die wieder stornierten Buchungen werden fr die Spendenquittungen nicht bercksichtigt.
        for habenkonto in self.habenKonten:
            # so braucht man im Falle eines Falles z.B. nur oben die Liste der Habenkonten zu erweitern.
            befehl = """select * from %s where %s in %s and Buchungsnummer not in %s %s and MZ like "%s" %s""" % (self.tabelle,habenkonto,Spendenkonten,stornos,auswahlliste_sql,MZ,spendenquittung)
            # print "befehl\n",befehl
            # eintragSuchfunktion(suchdict) funktioniert hier nicht wegen der where-Klausel.
            try:
                self.Cursor.execute(befehl)
                temp = self.Cursor.fetchall()
                # temp ist eine Liste von Tupeln:
                temp = self.alsDictionary(self.Spaltennamen,temp)
                for i in temp:
                    i["laufendeNummer"] = habenkonto[-1]
                    # die Nummer des gefundenen Habenkontos wird eingefgt fr sptere Auswertungen.                                
                    spendenbuchungen.append(i)
            except:
                pass
        spendenbuchungen.sort(lambda x,y: cmp(x["Belegdatum"], y["Belegdatum"]))
        return spendenbuchungen

    def spendenTabelleListe(self,schluesselliste,alleSpenden,auswahlliste=None):
        """Gibt einen Dictionary mit Spendentabellen (s.u.) zu
        allen bergebenen MZs in der Liste zurck.
        Die auswahlliste begrenzt auf bestimmte Buchungsnummern. Eigentlich nur sinnvoll,
        wenn fr eine einzelne MZ z.B. bestimmte Spendenbuchungen herausgefiltert werden sollen."""
        dict = {}
        for schluessel in schluesselliste:
            dict[schluessel] = self.spendenTabelle(schluessel,alleSpenden,auswahlliste=auswahlliste)
        return dict

    def spendenTabelle(self,MZ,alleSpenden,auswahlliste=None,doppelteBuchfuehrung="ja"):
        """Gibt eine Auswertungstabelle aller Spenden zu einer gegebenen MZ,
        die dann als dictarray direkt von baukontoweb weiterverarbeitet werden kann. Wenn
        alleSpenden = "nein", dann werden nur die Spenden bercksichtigt, fr die noch eine Quittung
        erstellt werden mu. Mit "auswahlliste" kann auf bestimmte Buchungsnummern eingegrenzt werden."""
        rueckgabedict = {}
        rohtabelle = self.spendenUebersicht(MZ,alleSpenden,auswahlliste=auswahlliste)
        endtabelle_kirchlich = []
        endtabelle_mildtaetig = []
        endtabelle_gesamt = []
        dummy = {"Squittung_noetig": "", "nochSquittung": "", "Buchungsnummer": "", "Belegdatum": "", "Betrag": "", "Konto": ""}
        dummy_kirchlich = dummy.copy()
        dummy_mildtaetig = dummy.copy()
        rueckgabedict["Spenderdaten"] = self.spendername(MZ)
        if not rohtabelle:
            # keine Spenden
            rueckgabedict["Spendensumme"] = "0.00"
        for buchung in rohtabelle:
            tempdict = {}
            tempdict["Squittung_noetig"] = buchung["Squittung_noetig"]
            tempdict["Buchungsnummer"] = buchung["Buchungsnummer"]
            tempdict["Belegdatum"] = buchung["Belegdatum"]
            if doppelteBuchfuehrung == "ja":
                tempdict["Konto"] = self.Kontenplan.hauptkontoname(buchung["Habenkonto_%s" % buchung["laufendeNummer"]])
                tempdict["Betrag"] = buchung["BetragHaben_%s" % buchung["laufendeNummer"]]
            else:
                tempdict["Konto"] = self.Kontenplan.hauptkontoname(buchung["Einnahmen"])
                tempdict["Betrag"] = buchung["Betrag"]
            if (buchung["Squittung_noetig"] in ["ja","kirchlich","mildttig"]) and buchung["Squittung_erstellt"] == "nein":
                tempdict["nochSquittung"] = "noch SQ"
            elif buchung["Squittung_erstellt"] != "nein":
                tempdict["nochSquittung"] = "SQ erstellt"
            else:
                tempdict["nochSquittung"] = "keine SQ"
            if tempdict["Squittung_noetig"] == "kirchlich":
                endtabelle_kirchlich.append(tempdict)
            elif tempdict["Squittung_noetig"] == "mildttig":
                endtabelle_mildtaetig.append(tempdict)
            else:
                endtabelle_kirchlich.append(tempdict) # fr Rckwrtskompatibilitt des Feldes Squittung_noetig in alten Datenbanken.
        #rueckgabedict["Buchungstabelle_kirchlich"] = endtabelle_kirchlich
        #rueckgabedict["Buchungstabelle_mildttig"] = endtabelle_mildtaetig
        temp_kirchlich = temp_mildtaetig = temp_gesamt = 0
        # wir machen zwei Durchlufe mit einem temp_gesamt, um Rundungsfehler auszuschalten:
        for i in endtabelle_kirchlich:
            temp_gesamt += float(i["Betrag"])
            temp_kirchlich += float(i["Betrag"])
        for i in endtabelle_mildtaetig:
            temp_gesamt += float(i["Betrag"])
            temp_mildtaetig += float(i["Betrag"])
        endtabelle_gesamt += endtabelle_kirchlich
        dummy_kirchlich.update({"Konto": "Gesamtsumme kirchliche Spenden:", "Betrag": "%.2f" % temp_kirchlich})
        endtabelle_gesamt.append(dummy_kirchlich)
        endtabelle_gesamt.append(dummy) # Leerzeile
        endtabelle_gesamt += endtabelle_mildtaetig
        dummy_mildtaetig.update({"Konto": "Gesamtsumme mildttige Spenden:", "Betrag": "%.2f" % temp_mildtaetig})
        endtabelle_gesamt.append(dummy_mildtaetig)
        rueckgabedict["Spendensumme"] = "%.2f" % temp_gesamt
        rueckgabedict["Buchungstabelle"] = endtabelle_gesamt
        return rueckgabedict
        
class BaukontoEvangKath(BaukontoNormal):
    def kontenInit(self):
        self.habenKonten = ["Einnahmen"]
        self.sollKonten = ["Ausgaben"]
        self.Konten = ["Einnahmen","Ausgaben"]
        
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="baukontoneu"):
        BaukontoNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)
        self.kontenInit()   #   - ntig hier!

    def spendenTabelle(self,MZ,alleSpenden,auswahlliste=None,doppelteBuchfuehrung="nein"):
        return BaukontoNormal.spendenTabelle(self,MZ,alleSpenden,auswahlliste=auswahlliste,doppelteBuchfuehrung=doppelteBuchfuehrung)

    def summeSollHaben(self,kontonummer,mitStornos="ja",mitKontonummer="ja",grundstueck=None,gemeinde=None,wformat="nein",mitVorzeichen="ja"):
        """Gibt den Saldo eines Kontos, gerechnet ber smtliche Buchungen. Bei 'mit Stornos' werden die
        Stornobuchungen mit bercksichtigt. => Achtung, nicht so in der Jahresstatistik!"""
        stornos = self.alleStornosSQL()
        Betrag = {"Betrag": 0}
        befehl = """select sum(Betrag) from %s where (Einnahmen like "%s" or Ausgaben like "%s") """ % (self.Tabellenname,kontonummer,kontonummer)
        if mitStornos == "nein":
            befehl += """ and Buchungsnummer not in %s """ % stornos
        if gemeinde is not None:
            befehl += """ and Gemeinde like "%s" """ % gemeinde
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchone()[0]
        if type(temp) == types.FloatType:
            Betrag["Betrag"] = temp
        if mitKontonummer=="ja":
            Betrag["Kontonummer"] = kontonummer
        if wformat == "ja":
            if mitVorzeichen == "nein":
                try:
                    temp = abs(temp)
                except:
                    pass   # fr die einfache Buchfhrung 
            Betrag["Betrag"] = self.wformat("%s" % temp)
        return Betrag

    def summeSollHabenHauptkonto(self,Hauptkonto,mitStornos="ja",mitKontonummer="ja"):
        return BaukontoNormal.summeSollHabenHauptkonto(self,Hauptkonto,mitStornos,mitKontonummer,var_dict={"Betrag": 0})  


    def storno(self,schluessel):
        """Klassisches Storno ohne Lschen des Eintrags."""
        stornodict = self.eintragSuchfunktion({primaerkartei: schluessel})[0]
        neudict = {}
        neudict.update(stornodict)
        neudict["Betrag"] = -(stornodict["Betrag"])
        neudict["Buchungstext"] = "Storno: "+stornodict["Buchungstext"]
        neudict["Stornonummer"] = schluessel
        return self.neuerEintrag(neudict)        

    def buchungPruefen(self,dict):
        """Eine entscheidende Funktion, die (leider?) hartcodiert und sehr spezialisiert ist."""
        flag = 1
        for i in self.Konten:
            if dict[i] in self.optionen.alleSpendenkonten() and dict["Squittung_noetig"] == "nein" and ("%s" % dict["Stornonummer"] == "0"):
                print "Achtung: Wirklich keine Spendenquittung fr %s?" % i
        if dict["Belegdatum"] == "-" or dict["Belegdatum"] == "00.00.0000":
            print "Sie mssen ein Belegdatum angeben!"
            flag = 0
        try:
            temp = datumutilities.Datum(dict["Belegdatum"])
        except:
            print "Das Belegdatum ist ungltig(falsches Format, nichtexistentes Datum)!"
            flag = 0            
        if dict["Buchungstext"] == "-":
            print "Sie mssen einen Buchungstext angeben!"
            flag = 0
        try:
            if dict["Spendername"] != self.spendername(dict["MZ"])["Spendername"]:
                print "MZ und Spendername stimmen nicht berein!"
                flag = 0
        except:
            # Wenn der Spendername nicht relevant ist und der dict die keys nicht hat.
            pass
        if dict["Einnahmen"] != "-" and dict["Ausgaben"] != "-":
            print "Entscheiden Sie sich: Einnahmen oder Ausgaben?"
            flag = 0
        if dict["Einnahmen"] == "-" and dict["Ausgaben"] == "-":
            print "Einnahmen und Ausgaben drfen nicht unbestimmt bleiben!"
            flag = 0
        kontenflag = 0
        for i in self.Konten:
            if dict[i] != "-":
                kontenflag = 1
                try:
                    temp = self.Kontenplan.schluesselSuchen(dict[i])[0]
                except:
                    print "Fr %s: Kontonummer existiert nicht!" % i
                # print "temp",temp,"dict[i]",dict[i],"\n"
                if temp["GemeindeNoetig"] == "ja" and dict["Gemeinde"] == "-":
                    print "Fr %s: Sie mssen eine Gemeinde angeben!" % i
                    flag = 0
                if temp["MZNoetig"] == "ja" and "%s" % dict["MZ"] == "0":
                    print "Fr %s: Sie mssen eine Person mit MZ angeben!" % i
                    flag = 0
        if kontenflag == 0:
            print "Sie haben keine Konten angegeben!"
            flag = 0
        return flag    


def Baukonto(MysqlDatenbank,buchungsjahr,datenbank="",tabelle="baukontoneu"):
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)
    if kirche == "metho":
        return BaukontoNormal(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    elif kirche in ("evang","kath"):
        return BaukontoEvangKath(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
        

   
##    def sichernCSV(self):
##        self.datenSichernCSV(backupdatei)


  
  
   

   

