#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import htmlutilities
import sys
import re
import string
import sortieren
import urllib
import types
import baukontomysql
import gemeindekarteiweb
import kontenplan
import optionen
import verschiedeneUtilities


primaerkartei = 'Buchungsnummer'

class BaukontoWebNormal(gemeindekarteiweb.GemeindeverwaltungWeb):
    
    def __init__(self,MysqlDatenbank,Buchungsjahr,dictarray,schaltzentrale,alleSpalten,schluessel=None,datumumwandeln="ja",betraege_umwandeln=[],kontennamen_umwandeln=[]):
        self.kontenplan = kontenplan.BaukontoKontenplan(MysqlDatenbank,Buchungsjahr)
        #self.htmlwerkzeug = htmlutilities.HtmlUtilities()
        # ist schon in der Superklasse!
        self.sortierwerkzeug = sortieren.Sortieren()
        self.optionswerkzeug = optionen.Optionen(MysqlDatenbank,buchungsjahr=Buchungsjahr)
        self.optionsfelder = self.optionswerkzeug.baukonto_optionsfelder()
        gemeindekarteiweb.GemeindeverwaltungWeb.__init__(self,dictarray,schaltzentrale,alleSpalten,schluessel)
        self.Konten = ["Habenkonto_1","Habenkonto_2","Habenkonto_3","Sollkonto_1","Sollkonto_2","Sollkonto_3"]
        self.Betraege = ["BetragHaben_1","BetragHaben_2","BetragHaben_3","BetragSoll_1","BetragSoll_2","BetragSoll_3"]
        self.betraege_umwandeln = betraege_umwandeln
        self.kontennamen_umwandeln = kontennamen_umwandeln
        

    def kontennamenVollstaendig(self):
        """Ersetzt alle Kontennummern durch vollstndige Kontennamen."""
        for zeile in self.dictarray:
            for kategorie in self.alleSpalten:
                zeile[kategorie] = self.kontennamenVollstaendigEinzeln(zeile[kategorie],kategorie)
          

    def kontennamenVollstaendigEinzeln(self,wert,kategorie=None):
        if kategorie is None:
            kategorie = self.Konten[0]
            # ein Dummy-Wert, damit man auch ohne kategorie aufrufen kann.
        try:
            if kategorie in self.Konten or kategorie in self.kontennamen_umwandeln:
                wert = self.kontenplan.kontonameVollstaendig(wert)
            return wert
        except:
            return wert

    def aenderungsformular(self,aktion="BaukontoBuchungTesten",submit="Buchung prfen"):
        return gemeindekarteiweb.GemeindeverwaltungWeb.aenderungsformular(self,optionsfelder=self.optionsfelder,aktion=aktion,skript=self.schaltzentrale,submit=submit)

    def datensatzkurztabelle(self):
        kategorien = self.baukonto.Spaltennamen
        return gemeindekarteiweb.GemeindeverwaltungWeb.datensatzkurztabelle(self,kategorien)

    def kontenSollHaben(self,smartlink,aktion,kategorien=None):
        """Zur Anzeige der Haupt- bzw. Unterkonten in bersicht."""
        # smartlink enthlt in der Regel "Hauptkonto" oder "Kontonummer". 
        if kategorien is None:
            kategorien = self.alleSpalten
        self.wformatAlle()
        for zeile in self.dictarray:
            zeile[smartlink] = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': zeile[smartlink],'Aktion': aktion},self.kontennamenVollstaendigEinzeln(zeile[smartlink],smartlink))
        return gemeindekarteiweb.GemeindeverwaltungWeb.datensatzkurztabelle(self,kategorien)
        

    def buchungsanzeige(self,mitLinks="nein"):
        self.kontennamenVollstaendig()
        self.wformatAlle()
        temp = self.tabelleErstesElement(border="1",weite="90%",aufspalten="ja")
        if mitLinks == "ja":
            smartlink1 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': self.schluessel,'Aktion':'BaukontoAlsVorlageSpeichern'},"als Vorlage")
            smartlink2 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': self.schluessel,'Aktion':'BaukontoStornoPruefen'},"Storno")
            temp += "<p><H4>%s &nbsp;&nbsp; %s</H4>" % (smartlink1, smartlink2)
        return temp

    def wformat(self,kategorie,string):
        """Umwandlung in Whrungsformat mit zwei Nachkommastellen."""
        if kategorie in self.Betraege or kategorie in self.betraege_umwandeln:
            string = "%.2f" % round(float(string),2)
            if string == "0.00":
                return "-"
            else:
                return string
        else:
            return string

    def wformatAlle(self):
        for zeile in self.dictarray:
            for i in zeile.keys():
                zeile[i] = self.wformat(i,zeile[i])

    def reportSpalte(self,liste,aktuelldict,zusatzanzeige=0):
        """Wandelt eine bergebene Liste von Kategorien in  HTML um, prft, ob einzelne
        Elemente leer (also gleich "-" sind, entsprechend der Buchungstabellensystematik).
        aktuelldict enthlt eine Zeile des dictarrays, dort werden dann die Werte nachgesehen."""
        tempstring = ""
        for kategorie in liste:
            wert = aktuelldict[kategorie]
            if (wert != "0.00") and (wert != "-"):
                if zusatzanzeige != 0:
                    # mit Kategorienanzeige
                    tempstring += "%s: %s<br>" % (kategorie,self.wformat(kategorie,wert))
                else:
                    tempstring += "%s<br>" % self.wformat(kategorie,wert)
                    # ohne Kategorienanzeige
        if tempstring != "":
            # Das letzte "<br>" wird ggf. abgeschnitten
            return tempstring[:-4]
        else:
            # ein Leerzeichen fr Netscape-Tabellen
            return "&nbsp;"

    def spendenReport(self,spenderdaten={},spendencheck="ja"):
        gesamtmatrix = []
        rueckgabe = ""
        if spendencheck == "ja":
            rueckgabe = """<form action = %s>""" % self.schaltzentrale
        for zeile in self.dictarray:
            tempzeile = []
            if zeile["Belegdatum"] == "-":
                # Hier werden Leer- und Summenzeilen behandelt. Das leere Datum wurde bereits
                # bei der Initialisierung in "-" umgewandelt.
                tempzeile = ["&nbsp;","<b>%s</b>" % zeile["Konto"],"<b>%s</b>" % zeile["Betrag"],"&nbsp;","&nbsp;"]
            else:                
                tempzeile.append(zeile["Belegdatum"])
                tempzeile.append(self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': zeile["Buchungsnummer"],'Aktion':'BaukontoBuchungAnzeigen'},zeile["Konto"]))
                # tempzeile.append(zeile["Konto"])
                tempzeile.append("%.2f" % float(zeile["Betrag"]))
                tempzeile.append(zeile["Squittung_noetig"].replace("nein","-"))
                tempzeile.append(zeile["nochSquittung"])
                if spendencheck == "ja":
                    checked = ""
                    if zeile["nochSquittung"] == "noch SQ":
                        checked = """checked="checked" """
                    tempzeile.append("""<input type = "checkbox" name = "MZ%s" %s />""" % (zeile["Buchungsnummer"],checked))
                    # wir benutzen die MZ-Funktion - obwohl es sich eigentlich um Buchungsnummern handelt.
            gesamtmatrix.append(tempzeile)
        rueckgabe += self.htmlwerkzeug.tabelleMitInhalt(gesamtmatrix,border="1")
        if spendencheck == "ja":
            Aktion = "BaukontoAuswahlSpeichern"
            rueckgabe += """
            <input type = "submit" name = "sq_erstellen" value = "Spendenquittungen fr Auswahl"/>
            <input type = "hidden" name = "Aktion" value = "%s" />
            <input type = "hidden" name = "schluessel" value = "%s" />
            </form>""" % (Aktion,spenderdaten.get("MZ",""))
        return rueckgabe

    def belegnummernReport(self):
        matrix = [["<H4>Beleg</H4>","<H4>Buchungstext</H4>","<H4>Gemeinde<br>Grundstck<br>Spendername</H4>","<H4>Soll</H4>","<H4>Betrag</H4>","<H4>Haben</H4>","<H4>Betrag</H4>"]]
        self.kontennamenVollstaendig()
        # auch die Kontenbezeichnungen anzeigen
        for zeile in self.dictarray:
            tempzeile = []
            tempzeile.append(self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': zeile["Buchungsnummer"],'Aktion':'BaukontoBuchungAnzeigen'},zeile["Belegnummer"]))
            # tempzeile.append(zeile["Belegnummer"])
            tempzeile.append(zeile["Buchungstext"])
            tempzeile.append(self.reportSpalte(("Gemeinde","Grundstueck","Spendername"),zeile,zusatzanzeige=1))
            tempzeile.append(self.reportSpalte(("Sollkonto_1","Sollkonto_2","Sollkonto_3"),zeile))
            tempzeile.append(self.reportSpalte(("BetragSoll_1","BetragSoll_2","BetragSoll_3"),zeile))
            tempzeile.append(self.reportSpalte(("Habenkonto_1","Habenkonto_2","Habenkonto_3"),zeile))
            tempzeile.append(self.reportSpalte(("BetragHaben_1","BetragHaben_2","BetragHaben_3"),zeile))
            matrix.append(tempzeile)
        # colgroups = ["width=10%","width=1%","width=10%","width=25%","width=10%","width=25%","width=10%"]
        return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1",fontsize="-1") 

    def datensatzkurz(self,vorlage="nein",normal="ja"):
        gesamtmatrix = []
        gesamtmatrix.append(["<b>Belegnummer</b>","<b>Buchungstext</b>","<b>Betrag</b>","&nbsp;","&nbsp;","&nbsp;"])
        for i in self.dictarray:
            tempmatrix = []
            if normal == "ja":
                summe = "%.2f" % (float(i["BetragSoll_1"])+float(i["BetragSoll_2"])+float(i["BetragSoll_3"]))
            elif normal == "nein":
                summe = "%.2f" % float(i["Betrag"])
            tempmatrix += [i["Belegnummer"],i["Buchungstext"],summe]
            if vorlage == "nein":
                smartlink1 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'BaukontoBuchungAnzeigen'},"Alles")
                smartlink2 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'BaukontoAlsVorlageSpeichern'},"Vorlage")
                smartlink3 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'BaukontoStornoPruefen'},"Storno")
                tempmatrix += [smartlink1,smartlink2,smartlink3]
            else:
                smartlink1 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'BaukontoVorlageAnzeigen'},"Alles")
                smartlink2 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'BaukontoVorlageUebernehmen'},"bernehmen")
                smartlink3 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[primaerkartei],'Aktion':'BaukontoVorlageLoeschen'},"Lschen")
                tempmatrix += [smartlink1,smartlink2,smartlink3]
            gesamtmatrix.append(tempmatrix)
        return self.htmlwerkzeug.tabelleMitInhalt(gesamtmatrix,border="1")


class BaukontoWebEvangKath(BaukontoWebNormal):
    def __init__(self,MysqlDatenbank,Buchungsjahr,dictarray,schaltzentrale,alleSpalten,schluessel=None,datumumwandeln="ja",betraege_umwandeln=[],kontennamen_umwandeln=[]):
        self.kontenplan = kontenplan.BaukontoKontenplan(MysqlDatenbank,Buchungsjahr)
        self.sortierwerkzeug = sortieren.Sortieren()
        self.optionswerkzeug = optionen.Optionen(MysqlDatenbank,buchungsjahr=Buchungsjahr)
        self.optionsfelder = self.optionswerkzeug.baukonto_optionsfelder()
        gemeindekarteiweb.GemeindeverwaltungWeb.__init__(self,dictarray,schaltzentrale,alleSpalten,schluessel)
        self.Konten = ["Einnahmen","Ausgaben"]
        self.Betraege = ["Betrag"]
        self.betraege_umwandeln = betraege_umwandeln
        self.kontennamen_umwandeln = kontennamen_umwandeln

    def datensatzkurz(self,vorlage="nein"):
        return BaukontoWebNormal.datensatzkurz(self,vorlage,normal="nein")

    def belegnummernReport(self):
        matrix = [["<H4>Beleg</H4>","<H4>Buchungstext</H4>","<H4>Gemeinde<br>Spendername</H4>","<H4>Einnahmen</H4>","<H4>Betrag</H4>","<H4>Ausgaben</H4>","<H4>Betrag</H4>"]]
        self.kontennamenVollstaendig()
        # auch die Kontenbezeichnungen anzeigen
        for zeile in self.dictarray:
            tempzeile = []
            tempzeile.append(self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': zeile["Buchungsnummer"],'Aktion':'BaukontoBuchungAnzeigen'},zeile["Belegnummer"]))
            # tempzeile.append(zeile["Belegnummer"])
            tempzeile.append(zeile["Buchungstext"])
            tempzeile.append(self.reportSpalte(("Gemeinde","Spendername"),zeile,zusatzanzeige=1))
            if zeile["Einnahmen"] != "-":
                tempzeile.append(self.reportSpalte(("Einnahmen",),zeile))
                tempzeile.append(self.reportSpalte(("Betrag",),zeile))
            else:
                tempzeile.append("&nbsp;")
                tempzeile.append("&nbsp;")
            if zeile["Ausgaben"] != "-":
                tempzeile.append(self.reportSpalte(("Ausgaben",),zeile))
                tempzeile.append(self.reportSpalte(("Betrag",),zeile))
            else:
                tempzeile.append("&nbsp;")
                tempzeile.append("&nbsp;")
            matrix.append(tempzeile)
        # colgroups = ["width=10%","width=1%","width=10%","width=25%","width=10%","width=25%","width=10%"]
        return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1",fontsize="-1") 

def BaukontoWeb(MysqlDatenbank,Buchungsjahr,dictarray,schaltzentrale,alleSpalten,schluessel=None,datumumwandeln="ja",betraege_umwandeln=[],kontennamen_umwandeln=[]):
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)
    if kirche == "metho":
        return BaukontoWebNormal(MysqlDatenbank,Buchungsjahr,dictarray,schaltzentrale,alleSpalten,schluessel,datumumwandeln,betraege_umwandeln,kontennamen_umwandeln)
    elif kirche in ("evang","kath"):
        return  BaukontoWebEvangKath(MysqlDatenbank,Buchungsjahr,dictarray,schaltzentrale,alleSpalten,schluessel,datumumwandeln,betraege_umwandeln,kontennamen_umwandeln)

   
          
