#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import string
import re
import time

_wochentage = ['Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag','Sonntag']
_monate = ['Januar','Februar','Mrz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember']
_de_format_re = re.compile(r'(\d?\d)\.(\d?\d)\.(\d\d\d\d)')
_de_format_wildcard = re.compile(r'(.?.)\.(.?.)\.(.?.?.?.)')
# dieser Regex ist noch zu verbessern, so da er auch auf
# die Wildcards * und ? testet.

normalDate._dayOfWeekName = _wochentage
normalDate._monthName = _monate
##Die letzteren beiden Zuweisungen ein frecher Einbruch
##in einen fremden globalen Namensraum...

class Datum(normalDate.NormalDate):
    """
    Diese Klasse nimmt verschiedene Anpassungen und Ergaenzungen an normalDate vor,
    besonders, was das Einlesen von Daten und die deutschen Gepflogenheiten betrifft.
    Dank an den Autor von normalDate.py
    """  

    def __init__(self,normalDateWert=None,sprache=None):
        # ******** berarbeiten!!! ***********
        normalDateWert = normalDateWert
        if (sprache == "deutsch") and (normalDateWert != None):
            normalDateWert = self.deutschesFormatEinlesen(normalDateWert)
        elif normalDateWert is not None:
            # wenn keine Umwandlung aus deutschem Format (Rckgabe im Tupel!)
            # dann alternativ (wegen des Tupels) Test auf MySQL-Format
            if type(normalDateWert) is type("a"):
                # so liest es auch das MySQL-Format ein (JJJJ-MM-TT):
                # nur bei Strings, nicht bei der Initialisierung durch Integer!
                normalDateWert = string.replace(normalDateWert,'-','')
        if normalDateWert == "00000000":
            normalDateWert = "18000101"
            # falls aus der MySQL-Datenbank ein
            # Nullwert kommt.
        #print normalDateWert
        # falls es im MySQL-Format yyyy-mm-dd kommt
        normalDate.NormalDate.__init__(self,normalDateWert)
        
    def deutschesFormatEinlesen(self,wert):
        # ******* Eine reine Werkzeug-Funktion - in dieser Form
        # ******* zum Parsen von Eingabeformularen und Weitergeben
        # an MySQL-Abfragen
        treffer = _de_format_re.search(wert)
        trefferwildcard = _de_format_wildcard.search(wert)
        if treffer:
            tag = "%02d" % int(treffer.group(1))
            monat = "%02d" % int(treffer.group(2))
            jahr = "%04d" % int(treffer.group(3))
            return jahr+monat+tag
            #return (int(jahr),int(monat),int(tag))

        elif trefferwildcard:
            return trefferwildcard.group(3)+trefferwildcard.group(2)+trefferwildcard.group(1)        
        else:
            ## Das Datum fr alle Zwecke...:
            # print "datumutilities.deutschesFormatEinlesen: Falsches Eingabeformat!"
            return ("18000101")

          

    def deutschesFormat(self):
        d = normalDate.NormalDate.__repr__(self)
        return "%s.%s.%s" % (d[-2:],d[-4:-2],d[-8:-4])

    def deutschesFormatText(self):
        d = normalDate.NormalDate.__repr__(self)
        return "%s. %s %s" % (d[-2:],self.monthName(),d[-8:-4])

    ##  def __repr__(self):
##        return self.deutschesFormat()
        
    def mysqlFormat(self):
        d = normalDate.NormalDate.__repr__(self)
        return "%s-%s-%s" % (d[-8:-4],d[-4:-2],d[-2:])

    def alter(self,stichtag):
        if self.__repr__()=="18000101":
            return "-"
        else:
            return (stichtag.year()-self.year())

    def alter_geburtstag(self,im_jahr):
        if self.__repr__()=="18000101":
            return "-"
        else:
            return (im_jahr-self.year())        

    def localeFormat(self):
        return self.deutschesFormat()

    def letzterWochentagImMonat(self,wochentag):
        """Gibt den Tag des letzten Montags, Dienstags...
        im Monat zurck als Integer"""
        if wochentag not in range(0,7):
            print "Datum.letzterWochentagImMonat: Wochentage nur von 0-6!"
            return 0
        letzterTag = self.lastDayOfMonth()
        temp = self.endOfMonth()
        letzterWochentag = temp.dayOfWeek()
        return letzterTag - (letzterWochentag-wochentag)%7

    def letzterWochentagImMonatDatum(self,wochentag):
        """Gibt den Tag des letzten Montags, Dienstags...
        zurck als Datum-Objekt"""        
        tag = self.letzterWochentagImMonat(wochentag)
        return Datum(self.__repr__()[:-2]+str(tag))

    def ersterWochentagImMonat(self,wochentag):
        """Gibt den Tag des ersten Montags, Dienstags...
        zurck als Integer"""
        if wochentag not in range(0,7):
           print "Datum.ersterWochentagImMonat: Wochentage nur von 0-6!"
           return 0
        temp = self.firstDayOfMonth()
        ersterWochentag = temp.dayOfWeek()
        return (wochentag-ersterWochentag)%7 + 1

    def ersterWochentagImMonatDatum(self,wochentag):
        """Gibt den Tag des ersten Montags, Dienstags...
        zurck als Datum-Objekt"""
        tag = self.ersterWochentagImMonat(wochentag)
        return Datum(self.__repr__()[:-2]+'0'+str(tag))

    def wochentagImMonat(self,wochentag,wievielter):
        """Gibt das Datum des n-ten Montags, Dienstags...
        zurck als Datum-Objekt"""
        erster = self.ersterWochentagImMonat(wochentag)
        nter = "%02d" % (erster + 7*(wievielter-1))
        string1 = self.__repr__()[:-2] + nter
        if self._isValidNormalDate(int(string1)):
            # _isValidNormalDate verarbeitet nur das Integer-Format
            return Datum(string1)
        else:
            print "Datum.wochentagImMonat(): angeforderter Tag existiert nicht!"
            return 0

    def inAllenMonaten(self,tag):
        """Gibt eine Liste mit allen 15. oder 30. usw.
        im aktuellen Jahr."""
        liste = []
        for monat in range(1,13):
            try:
                temp = Datum((self.year(),monat,tag))
            except:
                temp = None
            liste.append(temp)
        return liste

    def alleWochentageImJahr(self,tag):
        liste = []
        alle_ersten = self.inAllenMonaten(1)
        for monatserster in alle_ersten:
            letzter = monatserster.letzterWochentagImMonatDatum(tag)
            for i in range(1,6):
                temp = monatserster.wochentagImMonat(tag,i)
                liste.append(temp)
                if temp == letzter:
                    break
        return liste

    def istInWoche(self,datum):
        letzterWochentag = self + 6
        if self <= datum <= letzterWochentag:
            return 1
        else:
            return 0
                 
                
                    
                

    def zeitstempel(self):
        """Gibt einen Zeitstempel zurck, z.B. zur Kennzeichnung von Backups.
        z.B 'Tag_2002_11_24_Zeit_18_21' Beachte die ISO-Darstellung beim Datum - ermglicht
        leichteres Sortieren."""
        return time.strftime("Tag_%Y_%m_%d_Zeit_%H_%M",time.localtime())
        

    
    
            
        
        
