#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import verwaltungmysql
import sortieren
import verschiedeneUtilities


primaerkartei = 'Kontonummer'
backupdatei = "/windowsc/Martin/verwalt/Gemeindekartei/bezirksreiterbaukonto_kontenplan.txt"
if sys.platform[:3]=="win":
    backupdatei = r"c:\Martin\verwalt\Gemeindekartei\bezirksreiterbaukonto_kontenplan.txt"
    # anderer Pfad fr Windows

class BaukontoKontenplanNormal(verwaltungmysql.MySQLZugriff):

    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="baukontoneu_kontenplan"):
        self.buchungsjahr = buchungsjahr
        self.tabelle = "%s%s" % (tabelle,self.buchungsjahr)
        verwaltungmysql.MySQLZugriff.__init__(self,MysqlDatenbank,datenbank,self.tabelle)

    def primaerschluessel(self):
        return primaerkartei

    
    def sicherungsdatei(self):
        return backupdatei
    

    def eintragLoeschen(self,primaerdummy=primaerkartei,schluesselwert=None):
        """berschreibt die gleichnamige Funktion aus MySQLZugriff"""
        primaerdummy=primaerkartei # s.oben
        return verwaltungmysql.MySQLZugriff.eintragLoeschen(self,primaerdummy,schluesselwert)
            

    def eintragVergleichen(self,schluessel,vergleichdict):
        vergleichdictvollstaendig = self.leererEintrag
        vergleichdictvollstaendig.update(vergleichdict)
        # wichtig, wenn in vergleichdict bestimmte Eintrge fehlen,
        # die z.B. in einem Eingabeformular von "Name" auf "" gesetzt wurden.
        # Sie wrden sonst nicht verglichen (vgl. die Superklasse).
        return verwaltungmysql.MySQLZugriff.eintragVergleichen(self,{primaerkartei:schluessel},vergleichdictvollstaendig)

    def schluesselSuchen(self,schluessel):
        return self.eintragSuchfunktion({primaerkartei: schluessel})

    def kontonameVollstaendig(self,schluessel):
        temp = self.schluesselSuchen(schluessel)
        try:
            return """%s: %s""" % (schluessel,temp[0]["Kontoname"])
        except:
            return "-"

    def kontoname(self,schluessel):
        temp = self.schluesselSuchen(schluessel)
        try:
            return "%s" % temp[0]["Kontoname"]
        except:
            return "-"

    def hauptkontoname(self,schluessel):
        """Gibt zu einer Kontonummer den Namen des zugehrigen Hauptkontos."""
        temp = self.schluesselSuchen(schluessel)[0]
        try:
            temp2 = self.schluesselSuchen(temp["Hauptkonto"])
            return "%s" % temp2[0]["Kontoname"]
        except:
            return "-"

    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel=""):
        # Parameter "primaerschluessel" nur aus Kompatibilitt, damit die Schnittstelle
        # noch 4 Parameter hat.
        if aenderungsdict.has_key(primaerkartei):
            # kein ndern des Primrschlssels!
            del aenderungsdict[primaerkartei]
        verwaltungmysql.MySQLZugriff.eintragAendern(self,aenderungsdict,primaerkartei,schluessel)

    def sollkontenListeWeb(self):
        befehl = """select Kontonummer,Kontoname from %s where SollMoeglich like "ja" order by Kontonummer""" % self.Tabellenname
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        # Kontonummern und -namen, durch ":" getrennt, geordnet 
        return ["-"] + [i[0]+": "+i[1] for i in temp]
    
    def habenkontenListeWeb(self):
        befehl = """select Kontonummer,Kontoname from %s where HabenMoeglich like "ja" order by Kontonummer""" % self.Tabellenname
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        return ["-"] + [i[0]+": "+i[1] for i in temp]

  ##  def kontenListe(self):
##        befehl = """select Kontonummer from %s order by Kontonummer""" % self.Tabellenname
##        self.Cursor.execute(befehl)
##        temp = self.Cursor.fetchall()
##        return [i[0] for i in temp]

##    def hauptkontenListe(self):
##        befehl = """select distinct Hauptkonto from %s order by Hauptkonto""" % self.Tabellenname
##        self.Cursor.execute(befehl)
##        temp = self.Cursor.fetchall()
##        return [i[0] for i in temp]
    def kontenListe(self):
        return self.werteListe("Kontonummer")

    def hauptkontenListe(self):
        return self.werteListe("Hauptkonto",distinct="ja")

    def alleUnterkonten(self,Hauptkontonummer,mitHauptkonto="ja"):
        zusatz = ""
        if mitHauptkonto == "nein":
            zusatz = """ and Kontonummer not like "%s" """ % Hauptkontonummer            
        befehl = """select Kontonummer from %s where Hauptkonto like "%s" %s order by Kontonummer""" % (self.Tabellenname, Hauptkontonummer,zusatz)
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        return [i[0] for i in temp]

class BaukontoKontenplanEvangKath(BaukontoKontenplanNormal):
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="baukontoneu_kontenplan"):
        BaukontoKontenplanNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    def sollkontenListeWeb(self):
        pass

    def habenkontenListeWeb(self):
        pass

    # TODO: noch eine Testfunktion fr Neueintrge schreiben?

    def kontenListeWeb(self,einnahmen_ausgaben):
        befehl = """select Kontonummer,Kontoname from %s where EinnahmenAusgaben like "%s" order by Kontonummer""" % (self.Tabellenname,einnahmen_ausgaben)
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        # Kontonummern und -namen, durch ":" getrennt, geordnet 
        return ["-"] + [i[0]+": "+i[1] for i in temp]

    

   
def BaukontoKontenplan(MysqlDatenbank,buchungsjahr,datenbank="",tabelle="baukontoneu_kontenplan"):
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)
    if kirche == "metho":
        return BaukontoKontenplanNormal(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    elif kirche in ("evang","kath"):
        return BaukontoKontenplanEvangKath(MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    
